<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { NextStep } from '~/components/common/index.vue';
import { toKebabCase } from '@/lib/utils';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful.js';
import {
  LicensingFaqData,
  licensingFaqHelper,
} from '~/services/pricing/licensing-faq.service';

export default Vue.extend({
  components: {
    NextStep,
  },
  nuxtI18n: false,
  async asyncData() {
    const content: LicensingFaqData = await getClient()
      .getEntries({
        content_type: CONTENT_TYPES.PAGE,
        include: 10,
        'sys.id': '3yyPjJqG3RLJ5wM6xLaTrb',
      })
      .then((query: any) => {
        const entryFields = query.items[0]?.fields;
        return licensingFaqHelper(entryFields);
      })
      .catch(console.error);

    const anchorsData = content.sections.reduce((array: any, section: any) => {
      /* nodes */
      const nodes = section.singleAccordionGroupItems.reduce(
        (nodesArray: any, item: any) => {
          const id = toKebabCase(item.header);
          nodesArray.push({
            text: item.header,
            href: `#${id}`,
            data_ga_name: id,
            data_ga_location: 'side-navigation',
          });
          return nodesArray;
        },
        [],
      );
      /* sections */
      array.push({
        text: section.title,
        href: `#${section.id}`,
        data_ga_name: section.id,
        data_ga_location: 'side-navigation',
        nodes,
      });
      return array;
    }, []);

    const sideMenu = {
      anchors: { text: content.sideMenu.anchorsText, data: [...anchorsData] },
      hyperlinks: content.sideMenu.hyperlinks,
    };

    return { content, sideMenu };
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).content.metadata, this.$route.path);
  },
});
</script>

<template>
  <div class="licensing-faq">
    <SlpContainer>
      <SlpSideNavigation :data="sideMenu" class="licensing-faq__navigation">
        <template #header>
          <div class="licensing-faq__nav-buttons">
            <SlpButton
              v-for="(button, buttonIndex) in sideMenu.hyperlinks"
              :key="buttonIndex"
              :variant="button.variation"
              :href="button.externalUrl"
              :data-ga-name="button.dataGaName"
              :data-ga-location="button.dataGaLocation"
              >{{ button.text }}
              <SlpIcon
                v-if="button.iconName"
                class="slp-ml-8"
                :name="button.iconName"
                :variant="button.iconVariant"
                alt="Chevron Right Icon"
              />
            </SlpButton>
          </div>
        </template>
        <div class="header">
          <SlpTypography tag="h1" variant="heading1-bold">
            {{ content.title }}
          </SlpTypography>
        </div>
        <div class="licensing-faq__accordions">
          <PricingAuxFaq v-if="content.sections" :data="content.sections" />
        </div>
      </SlpSideNavigation>
      <SlpTopButton data-ga-name="to-top" data-ga-location="body" />
    </SlpContainer>
    <SlpContainer id="get-in-touch" variant="gradient">
      <NextStep
        :disable-animations="true"
        :variant="content.nextSteps.variant"
      />
    </SlpContainer>
  </div>
</template>

<style lang="scss">
.licensing-faq {
  #get-in-touch .slp-container.slp-my-96 {
    margin-top: 32px;
  }
  .header {
    margin-top: $spacing-64;
    @media (max-width: $breakpoint-md) {
      margin-top: $spacing-32;
    }
  }
  .dropdown {
    margin-top: $spacing-16;
  }
  &__accordions {
    margin-top: $spacing-64;
    @media (max-width: $breakpoint-md) {
      margin-top: $spacing-48;
    }
  }
  .faq-md {
    ul {
      list-style: revert;
      padding: revert;
    }
    h4 {
      font-size: $text-heading-4;
      line-height: $line-height-heading-4;
      font-weight: $font-weight-normal;
      letter-spacing: $letter-spacing-heading-4;

      @media (max-width: $breakpoint-sm) {
        font-size: $text-heading-4-mobile;
        line-height: $line-height-heading-4-mobile;
        font-weight: $font-weight-normal;
        letter-spacing: $letter-spacing-heading-4-mobile;
      }
    }
    h5 {
      font-size: $text-heading-5;
      line-height: $line-height-heading-5;
      font-weight: $font-weight-normal;
      letter-spacing: $letter-spacing-heading-5;

      @media (max-width: $breakpoint-sm) {
        font-size: $text-heading-5-mobile;
        line-height: $line-height-heading-5-mobile;
        font-weight: $font-weight-normal;
        letter-spacing: $letter-spacing-heading-5-mobile;
      }
    }
  }
  &__nav-buttons {
    width: 100%;
    margin-bottom: $spacing-24;

    .slp-btn {
      width: 100%;
      justify-content: center;
      margin-bottom: $spacing-8;
    }

    .slp-btn-secondary {
      padding: 11px 0;
    }
  }

  &__to-top {
    @media (max-width: $breakpoint-md) {
      display: none;
    }
  }

  &__navigation {
    &:deep(.dropdown) {
      margin: $spacing-32 0;
    }
  }
}
</style>
